/*
 *
 * Alpha.cpp
 *
 */
#include "Util.hpp"
#include "Alpha.hpp"

/* base codes
 * a = A = 0, c = C = 1, g = G = 2, t = T = u = U = 3
 * N R Y M K S W H B V D and X (and their lower case chars)
 * as ambiguous chars (= 4)
 * '.', '-', '_', and '~' are regarded as gap chars (= 5)
 * other characters are invalid (= 16)
 */
#define _ Alpha::INVALID_CODE
#define N Alpha::N_CODE 
#define g Alpha::GAP_CODE          
const int
Alpha::
nt2i[256] = {
 _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _,
 _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _,
 _, _, _, _, _, _, _, _, _, _, _, _, _, g, g, _,
 _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _,
 _, 0, N, 1, N, _, _, 2, N, _, _, N, _, N, N, _,
 _, _, N, N, 3, 3, N, N, N, N, _, _, _, _, _, g,
 _, 0, N, 1, N, _, _, 2, N, _, _, N, _, N, N, _,
 _, _, N, N, 3, 3, N, N, N, N, _, _, _, _, g, _,
 _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _,
 _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _,
 _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _,
 _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _,
 _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _,
 _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _,
 _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _,
 _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _,
};
#undef g
#undef N
#undef _

const int
Alpha::
i2nt[NCODE] = {
  'A','C','G','U','N','-','?'
};

const int
Alpha::
canonicalPairs[N_CANONICAL] = {
  AU_CODE,
  CG_CODE,
  GC_CODE, GU_CODE,
  UA_CODE, UG_CODE
};

const int
Alpha::
nonCanonicalPairs[N_NON_CANONICAL] = {
  AA_CODE, AC_CODE, AG_CODE,
  CA_CODE, CC_CODE, CU_CODE,
  GA_CODE, GG_CODE,
  UC_CODE, UU_CODE
};

const bool
Alpha::
isCanonicalBasePair[NPBASE] = {
  0, 0, 0, 1,
  0, 0, 1, 0,
  0, 1, 0, 1,
  1, 0, 1, 0
};
