/*
 * DPDeck.cpp
 *
 */
#include "DPDeck.hpp"

DPDeck::
DPDeck()
 : purpose(CYK), 
   cyk_mode(CYK_SMALL_CYK_MODE),
   score_mode(SCORE_MODE_GUES_BY_SIM), 
   maxMemory(1000), 
   dpAlongPath(false)
{
}
DPDeck::
~DPDeck()
{
}
string
DPDeck::
toString() const
{
  Die("method undefined");
  return "";
}
void
DPDeck::
print() const
{
  cout << toString() << flush;
}
void
DPDeck::
setPurpose(const string& purpose0)
{
  static const struct {string str; Purpose val;} pairs[] = {
    {"CYK", CYK},
    {"INSIDE_OUTSIDE", INSIDE_OUTSIDE},
    {"LIKELIHOOD", LIKELIHOOD}
  };
  static const int& nPairs = sizeof(pairs) / sizeof(pairs[0]);
  for (int i = 0; i < nPairs; i++) {
    if (purpose0 == pairs[i].str) {
      purpose = pairs[i].val;
      return;
    }
  }
  Die("bad purpose %s", purpose0.c_str());
}
void
DPDeck::
setCYKMode(const string& cyk_mode0)
{
  static const struct {string str; CYKMode val;} pairs[] = {
    {"CYK_SMALL_CYK", CYK_SMALL_CYK_MODE},
    {"CYK"          , CYK_MODE          },
    {"SMALL_CYK"    , SMALL_CYK_MODE    }
  };
  static const int& nPairs = sizeof(pairs) / sizeof(pairs[0]);
  for (int i = 0; i < nPairs; i++) {
    if (cyk_mode0 == pairs[i].str) {
      cyk_mode = pairs[i].val;
      return;
    }
  }
  Die("bad cyk_mode %s", cyk_mode0.c_str());
}
void
DPDeck::
setScoreMode(const string& modeName)
{
  static const struct {string str; ScoreMode val;} pairs[] = {
    {"SCORE_MODE_SIM_0", SCORE_MODE_SIM_0},
    {"SCORE_MODE_SIM_1", SCORE_MODE_SIM_1},
    {"SCORE_MODE_SIM_2", SCORE_MODE_SIM_2},
    {"SCORE_MODE_SIM_3", SCORE_MODE_SIM_3},
    {"SCORE_MODE_GUES_BY_SIM", SCORE_MODE_GUES_BY_SIM},
    {"SCORE_MODE_MEA",   SCORE_MODE_MEA}
  };
  static const int& nPairs = sizeof(pairs) / sizeof(pairs[0]);
  for (int i = 0; i < nPairs; i++) {
    if (modeName == pairs[i].str) {
      score_mode = pairs[i].val;
      return;
    }
  }
  Die("bad score_mode %s", modeName.c_str());
}
void
DPDeck::
setMaxMemory(const float& z)
{
  maxMemory = z;
}
void
DPDeck::
setDPAlongPath(const bool& dpAlongPath0)
{
  dpAlongPath = dpAlongPath0;
}
void
DPDeck::
setDoRefine(const bool& doRefine0)
{
  doRefine = doRefine0;
}
void
DPDeck::
setScoreParam(ScoreParam& scoreParam)
{
  Die("method undefined");
}
//void
//DPDeck::
//setScoreParamList(Vector<ScoreParam>& scoreParamList)
//{
//  Die("method undefined");
//}
void
DPDeck::
setGuideTree(GuideTree& guideTree)
{
}
void
DPDeck::
setRefinementStrategy(const string& strategy)
{
  //Warn("method undefined");
}
void
DPDeck::
setWeight(Weight& weights)
{
}
void 
DPDeck::
setMSAs(const MSA& msaX, const MSA& msaY,
	const UpTriMtx<float>& basePairProbX,
	const UpTriMtx<float>& basePairProbY)
{
  Die("method undefined");
}
void
DPDeck::
setSkipSize(int skipSize0)
{
}
int
DPDeck::
getSkipSize() const
{
  Warn("method undefined");
  return 1;
}
void 
DPDeck::
setPairProbData(const PairProbData& pairProbData)
{
}
void 
DPDeck::
setAlignProbData(const AlignProbData& AlignProbData)
{
}
void 
DPDeck::
getPairProb(UpTriMtx<float>& pairProb) const
{
  Die("method undefined");
}
void 
DPDeck::
setAlignProb(const NMatrix<float>& alignProb)
{
  Die("method undefined");
}
void 
DPDeck::
getAlignProb(NMatrix<float>& alignProb) const
{
  Die("method undefined");
}
float
DPDeck::
getDEDistance() const
{
  Die("method undefined");
  return 0.0;
}
Vector<float>
DPDeck::
computeFeatureVector() const
{
  Die("method undefined");
  return Vector<float>();
}
Vector<float>
DPDeck::
getParamVector() const
{
  Die("method undefined");
  return Vector<float>();
}
Vector<float>
DPDeck::
getParamVectorFromCountVector(const Vector<float>& countVector) const
{
  Die("method undefined");
  return Vector<float>();
}
int
DPDeck::
getParamVectorSize() const
{
  Die("method undefined");
  return (-1);
}
void
DPDeck::
setParamVector(const Vector<float>& pv)
{
  Die("method undefined");
}
string 
DPDeck::
featureVect2String(const Vector<float>& fv, const int& indentLevel) const
{
  Die("method undefined");
  return "";
}
float
DPDeck::
computeWorkspaceSizeInMB()
{
  return -1.0;
}
float
DPDeck::
computeDPIterationCountInUnitsOfMegaTimes() const
{
  return -1.0;
}
void
DPDeck::
printWorkspaceSize(ostream& fo)
{
}
void
DPDeck::
printDPIterationCounts(ostream& fo)
{
}
