/*
 * Dmtx.hpp
 *
 */
#ifndef DMTX_HPP
#define DMTX_HPP
#include "Util.hpp"

// class SeqIndexes;

class SeqIds;
class SeqData;
class MSA;
class Scheduler;

class Dmtx : private UpTriMtx<float> {
  typedef UpTriMtx<float> Super;
public:
  Dmtx();
  ~Dmtx();

  int length() const;
  const SeqIds& getSeqIds() const;
  float& ref(int i, int j);
  const float& ref(int i, int j) const;
  void setFromTupleCount(const SeqData& seqData, const SeqIds& seqIds0);
  void setFromSeqIdentity(const MSA& msa);
  void setFromMLDistance(SeqData& seqData, const SeqIds& seqIds0,
			 Scheduler& scheduler);
  void setFromMLDistance(MSA& msa, Scheduler& scheduler);
  void setFromAlignDistance(SeqData& seqData, const SeqIds& seqIds0,
			    Scheduler& scheduler);
  void setFromMSA(const MSA& msa, Scheduler& scheduler);
  float getMeanDistance() const;
  string toString() const;
  void print() const;
  static float jukes_cantor_dist(float identity);
  static float kimuraCorrect(float identity);

private:
  SeqIds& seqIds;

  Dmtx(const Dmtx& dmtx);
  Dmtx& operator=(const Dmtx& dmtx);

  void setLength(int length);

  //static float computeDistFromTupleCount(SeqIndexes& si1,
  //					 SeqIndexes& si2);
};

#endif
