/*
 * MultiFamAligner.hpp
 *
 */
#ifndef MULTI_FAM_ALIGNER_HPP
#define MULTI_FAM_ALIGNER_HPP

#include "Util.hpp"
#include "SeqData.hpp"

class MultiFamAligner {
public:
  MultiFamAligner(SeqData& seqData, SeqFamAligner& seqFamAligner,
		  int clientSize, bool pairwise, ostream& fo, ostream& fl);
  ~MultiFamAligner();
  void run();
  void printReport() const;

private:
  typedef map<SeqIds, string> ResultStrings;
  // static pthread_mutex_t mutex;
  class Client;
  SeqData& seqData;
  SeqFamAligner& seqFamAligner;
  //int clientSize;
  SeqData::FamilyIterator familyIterator;
  ResultStrings souts;
  ResultStrings slogs;
  bool pairwise;
  ostream& fo;
  ostream& fl;

  MultiFamAligner();
  MultiFamAligner(const MultiFamAligner& multiFamAligner);
  MultiFamAligner& operator=(const MultiFamAligner& multiFamAligner);
  friend void* MultiFamAligner_Client_run(void* pMultiFamAligner);
  friend class Client;
};

class MultiFamAligner::Client {
public:
  Client(MultiFamAligner& multiFamAligner);
  ~Client();
  void run();

private:
  MultiFamAligner& multiFamAligner;
};
#endif
