/*
 * MultipleAligner.cpp
 *
 */
#include "Util.hpp"
#include "Alpha.hpp"
#include "Vector.hpp"
#include "Rect.hpp"
#include "SeqData.hpp"
#include "Profile.hpp"
#include "MSA.hpp"
#include "ScoreParam.hpp"
#include "EScript.hpp"
#include "Dmtx.hpp"
#include "Weight.hpp"
#include "GuideTree.hpp"
#include "Cluster.hpp"
#include "Trapezoid.hpp"
#include "DPPath.hpp"
#include "DPRegion.hpp"
#include "DPDeck.hpp"
#include "Aligner.hpp"
#include "Job.hpp"
// #include "EvalAlign.hpp"
#include "Scheduler.hpp"
#include "SeqFamAligner.hpp"
#include "ProgressiveAligner.hpp"
// #include "IterativeAligner.hpp"
#include "MultipleAligner.hpp"

MultipleAligner::
MultipleAligner(SeqData& seqData,
		GuideTree& guideTree,
		Weight& weights,
		Scheduler& scheduler,
		int clientSize,
		float thresholdScoreRatio,
		int maxIter,
		int iterateSize,
		string outfile_format)
  : Super(seqData, scheduler),
    progAligner(seqData, guideTree, weights, scheduler, clientSize, outfile_format) // ,
    //iterAligner(seqData, guideTree, weights, scheduler, 
    //thresholdScoreRatio, maxIter, iterateSize)
{
}
MultipleAligner::
MultipleAligner(const MultipleAligner& multipleAligner)
  : Super(multipleAligner),
    progAligner(multipleAligner.progAligner) //,
  // iterAligner(multipleAligner.iterAligner)
{
}
MultipleAligner::
~MultipleAligner()
{
}
MultipleAligner&
MultipleAligner::
dup() const
{
  return *new MultipleAligner(*this);
}
void
MultipleAligner::
run()
{
  progAligner.setSeqIds(seqIds);
  progAligner.setSOut(*pSOut);
  progAligner.setSLog(*pSLog);
  progAligner.run();
  // iterAligner.setSeqIds(seqIds);
  // iterAligner.setSOut(*pSOut);
  // iterAligner.setSLog(*pSLog);
  // iterAligner.run();
}
