/*
 * MultipleAligner.hpp
 *
 */
#ifndef MULTIPLE_ALIGNER_HPP
#define MULTIPLE_ALIGNER_HPP
class 
MultipleAligner 
  : public SeqFamAligner 
{
public:
  MultipleAligner(SeqData& seqData, 
		  GuideTree& guideTree,
		  Weight& weights,
		  Scheduler& scheduler,
		  int clientSize,
		  float thresholdScoreRatio,
		  int maxIter,
		  int iterateSize,
		  string outfile_format);
  ~MultipleAligner();
  MultipleAligner& dup() const;
  void run();

private:
  typedef SeqFamAligner Super;
  ProgressiveAligner progAligner;
  // IterativeAligner iterAligner;

  MultipleAligner();
  MultipleAligner(const MultipleAligner& multipleAligner);
  MultipleAligner& operator=(const MultipleAligner& multipleAligner);
};
#endif
