/*
 * DPDeckSCFGDPLocals.hpp
 *
 */
#ifndef DP_DECK_PSCFG_DP_LOCALS_HPP
#define DP_DECK_PSCFG_DP_LOCALS_HPP

#include "Trapezoid.hpp"
#include "DPDeckPSCFG.hpp"
#include "PSCFGEnergyScoreManager.hpp"
// #include "PSCFGBaseScoreManager.hpp"
#include "DPDeckPSCFGNodes.hpp"
#include "DPDeckPSCFGDPRegion.hpp"
#include "DPDeckPSCFGDPRegionRegion.hpp"

template <typename Task>
class DPDeckPSCFG::DPLocals {
public:
  DPLocals(Task& task);
  //DPLocals(DPTask& dpTask, const DPRegion::Region& region);
  ~DPLocals();
  string toString() const;
  void print() const;
  void run();

  DPScoreT getFinalScore() const;
  State getFinalState() const;

private:
  enum PrevFlag {
    FLAG_NULL    = 0x0,
    FLAG_PREV_ML = 0x1,
    FLAG_PREV_IL = 0x2,
    FLAG_PREV_DL = 0x4,
  };
  enum BtFlag {
    BT_IS_GENERIC = 0x0,
    BT_IS_BT0     = 0x1,
    BT_IS_BT_LIM  = 0x2
  };
  enum BxFlag {
    BX_IS_GENERIC = 0x0,
    BX_IS_BX0     = 0x1,
    BX_IS_BX_LIM  = 0x2
  };
  enum BxIsOnSkip {
    BX_IS_ON_SKIP     = true,
    BX_IS_NOT_ON_SKIP = false
  };
  enum ByIsBy0 {
    BY_IS_BY0     = true,
    BY_IS_NOT_BY0 = false
  };
  enum BIsOnSkip {
    B_IS_ON_SKIP     = true,
    B_IS_NOT_ON_SKIP = false
  };
  enum EtIsEt0 {
    ET_IS_ET0     = true,
    ET_IS_NOT_ET0 = false
  };
  enum EtCmpByext {
    ET_LT_BYEXT = 0,
    ET_IS_BYEXT = 1,
    ET_GT_BYEXT = 2
  };
  enum ExIsEx0 {
    EX_IS_EX0     = true,
    EX_IS_NOT_EX0 = false
  };
  enum ExCmpByex {
    EX_LT_BYEX = 0,
    EX_IS_BYEX = 1,
    EX_GT_BYEX = 2
  };
  enum ExIsOnSkip {
    EX_IS_ON_SKIP     = true,
    EX_IS_NOT_ON_SKIP = false
  };
  enum EyIsEy0 {
    EY_IS_EY0     = true,
    EY_IS_NOT_EY0 = false
  };
  enum RectIsOnSkip {
    RECT_IS_ON_SKIP     = true,
    RECT_IS_NOT_ON_SKIP = false
  };
  enum ExyType {
    BE_IS_BE0      = 0,
    EXY_IS_EXY0    = 1,
    EXY_IS_GENERIC = 2
  };
  enum Forward {
    FORWARD  = true,
    BACKWARD = false
  };
  enum L1R2 {
    L1_R2 = true,
    L2_R1 = false
  };
  enum HasIntsec {
    HAS_INTSEC = true,
    NO_INTSEC  = false
  };
  enum MarginType {
    NO_MARGIN = 0x0,
    MARGIN_L  = 0x1,
    MARGIN_R  = 0x2,
    MARGIN_LR = 0x3
  };
  enum HasHEXN0 {
    HAS_H_EXN_0 = true,
    NO_H_EXN_0 = false
  };

  //template <int tzType0>
  //struct TZState
  //{
  //  enum {
  //    type = tzType0,
  //    isLD = ((tzType0 & Trapezoid::FLAG_LD) != 0),
  //    isRD = ((tzType0 & Trapezoid::FLAG_RD) != 0),
  //    dL   = (isLD ? 1 : 0),
  //    dR   = (isRD ? 1 : 0),
  //    dly  = dR - dL,
  //    topLeftMargin = (2 + 1), // add 1 to move
  //    bottomRightMargin = (2 + 1),
  //  };
  //  static string toString();
  //  static void print();
  //};
  //template <typename Task0, int btFlag0>
  //struct BT {
  //  typedef Task0 Task;
  //  enum {
  //    bt_is_bt0 = ((btFlag0 & BT_IS_BT0) != 0),
  //    bt_is_bt_lim = ((btFlag0 & BT_IS_BT_LIM) != 0),
  //    bt0_is_bt_lim = (bt_is_bt0 && bt_is_bt_lim)
  //  };
  //};
  //template <typename BT0, int tzType0, int bxFlag0>
  //struct BX : public BT0 {
  //  typedef TZState<tzType0> bt;
  //  enum {
  //    bx_is_bx0 = ((bxFlag0 & BX_IS_BX0) != 0),
  //    bx_is_bx_lim = ((bxFlag0 & BX_IS_BX_LIM) != 0),
  //    bx0_is_bx_lim = (bx_is_bx0 && bx_is_bx_lim),
  //    bx_is_btbx0 = (BT0::bt_is_bt0 && bx_is_bx0)
  //  };
  //};
  //template <typename BX0, bool bx_is_on_skip0,
  //	    bool by_is_by00, int prevFlags0>
  //struct BY : public BX0 {
  //  enum {
  //    bx_is_on_skip = bx_is_on_skip0,
  //    by_is_by0 = by_is_by00,
  //    bxy_is_bxy0 = (BX0::bx_is_btbx0 && by_is_by0),
  //    prevFlags = prevFlags0,
  //    hasPrevML = ((prevFlags & FLAG_PREV_ML) != 0),
  //    hasPrevIL = ((prevFlags & FLAG_PREV_IL) != 0),
  //    hasPrevDL = ((prevFlags & FLAG_PREV_DL) != 0)
  //  };
  //};
  ////template <typename BY0, bool b_is_on_skip0>
  ////struct BYK : public BY0 {
  ////  enum {
  ////    b_is_on_skip = b_is_on_skip0
  ////  };
  ////};
  //template <typename BY0, bool b_is_on_skip0,
  //	    bool et_is_et00, int et_cmp_byext0>
  //struct ET : public BY0 {
  //  enum {
  //    b_is_on_skip = b_is_on_skip0,
  //    et_is_et0         = et_is_et00,
  //    et_cmp_byext    = et_cmp_byext0,
  //    et_is_byext     = (et_cmp_byext == ET_IS_BYEXT),
  //    et_le_byext     = (et_cmp_byext <= ET_IS_BYEXT),
  //    et_lt_byext     = (et_cmp_byext <  ET_IS_BYEXT),
  //    et_ge_byext     = (et_cmp_byext >= ET_IS_BYEXT),
  //    et_gt_byext     = (et_cmp_byext >  ET_IS_BYEXT)
  //  };
  //};
  ////template <typename ET0, >
  ////struct ETT : public ET0 {
  ////  typedef TZState<tzType0> et;
  ////};
  //template <typename ET0, int tzType0, 
  //	    bool ex_is_ex00, int ex_cmp_byex0>
  //struct EX : public ET0 {
  //  typedef TZState<tzType0> et;
  //  enum {
  //    ex_is_ex0      = ex_is_ex00,
  //    ex_is_etex0    = (ET0::et_is_et0 && ex_is_ex0),
  //    ex_cmp_byex    = ex_cmp_byex0,
  //    ex_is_byex     = (ex_cmp_byex == EX_IS_BYEX),
  //    ex_le_byex     = (ex_cmp_byex <= EX_IS_BYEX),
  //    ex_lt_byex     = (ex_cmp_byex <  EX_IS_BYEX),
  //    ex_ge_byex     = (ex_cmp_byex >= EX_IS_BYEX),
  //    ex_gt_byex     = (ex_cmp_byex >  EX_IS_BYEX)
  //  };
  //};
  ////template <typename EX0, bool ex_is_on_skip0>
  ////struct EXK : public EX0 {
  ////  enum {
  ////    ex_is_on_skip = ex_is_on_skip0
  ////  };
  ////};
  //template <typename EX0, bool ex_is_on_skip0, bool ey_is_ey00>
  //struct EY : public EX0 {
  //  enum {
  //    ex_is_on_skip = ex_is_on_skip0,
  //    ey_is_ey0 = ey_is_ey00,
  //    exy_is_exy0 = (EX0::ex_is_etex0 && ey_is_ey0)
  //  };
  //};
  //template <typename EY0, bool rect_is_on_skip0>
  //struct EYK : public EY0 {
  //  enum {
  //    rect_is_on_skip = rect_is_on_skip0
  //  };
  //  static int getType() {
  //    if (EY0::bxy_is_bxy0 && EY0::exy_is_exy0) return BE_IS_BE0;
  //    if (EY0::exy_is_exy0) return EXY_IS_EXY0;
  //    
  //    return EXY_IS_GENERIC;
  //  }
  //};

  //struct TZState {
  //  int tzType;
  //  int isLD;
  //  int isRD;
  //  int dL;
  //  int dR;
  //  int dly;
  //  int topLeftMargin;
  //  int bottomRightMargin;
  //
  //  TZState(const int& tzType0)
  //    : tzType(tzType0),
  //	isLD((tzType0 & Trapezoid::FLAG_LD) != 0),
  //	isRD((tzType0 & Trapezoid::FLAG_RD) != 0),
  //	dL(isLD ? 1 : 0),
  //	dR(isRD ? 1 : 0),
  //	dly(dR - dL),
  //	topLeftMargin(2 + 1), // add 1 to move
  //	bottomRightMargin(2 + 1) {
  //  }
  //};
  //struct BT {
  //  int btFlag;
  //  int bt_is_bt0;
  //  int bt_is_bt_lim;
  //  int bt0_is_bt_lim;
  //  BT(const int& btFlag0) 
  //    : btFlag(btFlag0),
  //	bt_is_bt0((btFlag0 & BT_IS_BT0) != 0),
  //	bt_is_bt_lim((btFlag0 & BT_IS_BT_LIM) != 0),
  //	bt0_is_bt_lim(bt_is_bt0 && bt_is_bt_lim) {
  //  }
  //};
  //struct BX : public BT {
  //  TZState bt;
  //  int bxFlag;
  //  int bx_is_bx0;
  //  int bx_is_bx_lim;
  //  int bx0_is_bx_lim;
  //  int bx_is_btbx0;
  //  int bx_is_btbx_lim;
  //  BX(const BT& BT0, const int& tzType0, const int& bxFlag0)
  //    : BT(BT0),
  //	bt(tzType0),
  //	bxFlag(bxFlag0),
  //	bx_is_bx0((bxFlag0 & BX_IS_BX0) != 0),
  //	bx_is_bx_lim((bxFlag0 & BX_IS_BX_LIM) != 0),
  //	bx0_is_bx_lim(bx_is_bx0 && bx_is_bx_lim),
  //	bx_is_btbx0(BT0.bt_is_bt0 && bx_is_bx0),
  //	bx_is_btbx_lim(BT0.bt_is_bt_lim && bx_is_bx_lim) {
  //  }
  //};
  //struct BY : public BX {
  //  int bx_is_on_skip;
  //  int by_is_by0;
  //  int bxy_is_bxy0;
  //  int prevFlags;
  //  int hasPrevML;
  //  int hasPrevIL;
  //  int hasPrevDL;
  //  BY(const BX& BX0, const int& bx_is_on_skip0,
  //     const int& by_is_by00, const int& prevFlags0)
  //    : BX(BX0),
  //	bx_is_on_skip(bx_is_on_skip0),
  //	by_is_by0(by_is_by00),
  //	bxy_is_bxy0(BX0.bx_is_btbx0 && by_is_by0),
  //	prevFlags(prevFlags0),
  //	hasPrevML((prevFlags & FLAG_PREV_ML) != 0),
  //	hasPrevIL((prevFlags & FLAG_PREV_IL) != 0),
  //	hasPrevDL((prevFlags & FLAG_PREV_DL) != 0) {
  //  }
  //};
  //struct ET : public BY {
  //  int b_is_on_skip;
  //  int et_is_et0;
  //  int et_cmp_byext;
  //  int et_is_byext; 
  //  int et_le_byext; 
  //  int et_lt_byext; 
  //  int et_ge_byext; 
  //  int et_gt_byext;
  //  ET(const BY& BY0, const int& b_is_on_skip0,
  //     const int& et_is_et00, const int& et_cmp_byext0)
  //    : BY(BY0),
  //	b_is_on_skip(b_is_on_skip0),
  //	et_is_et0(et_is_et00),
  //	et_cmp_byext(et_cmp_byext0),
  //	et_is_byext(et_cmp_byext == ET_IS_BYEXT),
  //	et_le_byext(et_cmp_byext <= ET_IS_BYEXT),
  //	et_lt_byext(et_cmp_byext <  ET_IS_BYEXT),
  //	et_ge_byext(et_cmp_byext >= ET_IS_BYEXT),
  //	et_gt_byext(et_cmp_byext >  ET_IS_BYEXT) {
  //  }
  //};
  //struct EX : public ET {
  //  TZState et;
  //  int ex_is_ex0;
  //  int ex_is_etex0;
  //  int ex_cmp_byex;
  //  int ex_is_byex; 
  //  int ex_le_byex; 
  //  int ex_lt_byex; 
  //  int ex_ge_byex; 
  //  int ex_gt_byex;
  //  int hasPrevDR;
  //  EX(const ET& ET0, const int& tzType0, 
  //     const int& ex_is_ex00, const int& ex_cmp_byex0)
  //    : ET(ET0),
  //	et(tzType0),
  //	ex_is_ex0(ex_is_ex00),
  //	ex_is_etex0(ET0.et_is_et0 && ex_is_ex0),
  //	ex_cmp_byex(ex_cmp_byex0),
  //	ex_is_byex(ex_cmp_byex == EX_IS_BYEX),
  //	ex_le_byex(ex_cmp_byex <= EX_IS_BYEX),
  //	ex_lt_byex(ex_cmp_byex <  EX_IS_BYEX),
  //	ex_ge_byex(ex_cmp_byex >= EX_IS_BYEX),
  //	ex_gt_byex(ex_cmp_byex >  EX_IS_BYEX),
  //	hasPrevDR(ex_is_etex0) {
  //  }
  //};
  //struct EY : public EX {
  //  int ex_is_on_skip;
  //  int ey_is_ey0;
  //  int exy_is_exy0;
  //  EY(const EX& EX0, const int& ex_is_on_skip0, const int& ey_is_ey00)
  //    : EX(EX0),
  //	ex_is_on_skip(ex_is_on_skip0),
  //	ey_is_ey0(ey_is_ey00),
  //	exy_is_exy0(EX0.ex_is_etex0 && ey_is_ey0) {
  //  }
  //};
  //struct EYK : public EY {
  //  int rect_is_on_skip;
  //  int type;
  //  EYK(const EY& EY0, const int& rect_is_on_skip0)
  //    : EY(EY0),
  //	rect_is_on_skip(rect_is_on_skip0),
  //	type(getType_(EY0))
  //  {
  //  }
  //  static int getType_(const EY& EY0) {
  //    if (EY0.bxy_is_bxy0 && EY0.exy_is_exy0) return BE_IS_BE0;
  //    if (EY0.exy_is_exy0) return EXY_IS_EXY0;
  //    
  //    return EXY_IS_GENERIC;
  //  }
  //  int getType() const {return type;}
  //};

  typedef Trapezoid::TzType TzType;
  struct TZState {
    //TzType tzType                  : 2;
    //bool isLD                      : 1;
    //bool isRD                      : 1;
    //signed int dL                  : 2;
    //signed int dR                  : 2;
    //signed int dly                 : 4;
    TzType tzType                  ;
    bool isLD                      ;
    bool isRD                      ;
    int dL                         ;
    int dR                         ;
    int dly                        ;
    enum MarginSize {
      topLeftMargin     = (2 + 1),
      bottomRightMargin = (2 + 1)
    };
    void reset(const TzType& tzType0) {
      tzType = tzType0;

      isLD = ((tzType0 & Trapezoid::FLAG_LD) != 0);
      isRD = ((tzType0 & Trapezoid::FLAG_RD) != 0);
      dL = (isLD ? 1 : 0);
      dR = (isRD ? 1 : 0);
      dly = (dR - dL);
    }
  };
  struct StateFlags {

    //BT
    //BtFlag       btFlag          : 2;
    //bool         bt_is_bt0       : 1;
    //bool         bt_is_bt_lim    : 1;
    //bool         bt0_is_bt_lim   : 1;
    BtFlag       btFlag          ;
    bool         bt_is_bt0       ;
    bool         bt_is_bt_lim    ;
    bool         bt0_is_bt_lim   ;
    inline void resetBT(const BtFlag& btFlag0) {
      btFlag = (btFlag0);
      bt_is_bt0 = ((btFlag0 & BT_IS_BT0) != 0);
      bt_is_bt_lim = ((btFlag0 & BT_IS_BT_LIM) != 0);
      bt0_is_bt_lim = (bt_is_bt0 && bt_is_bt_lim);
    }

    //BX
    TZState      Bt;
    //BxFlag       bxFlag          : 2;
    //bool         bx_is_bx0       : 1;
    //bool         bx_is_bx_lim    : 1;
    //bool         bx0_is_bx_lim   : 1;
    //bool         bx_is_btbx0     : 1;
    //bool         bx_is_btbx_lim  : 1;
    BxFlag       bxFlag          ;
    bool         bx_is_bx0       ;
    bool         bx_is_bx_lim    ;
    bool         bx0_is_bx_lim   ;
    bool         bx_is_btbx0     ;
    bool         bx_is_btbx_lim  ;
    inline void resetBX(const BxFlag& bxFlag0) {
      bxFlag         = (bxFlag0);

      bx_is_bx0      = ((bxFlag0 & BX_IS_BX0) != 0);
      bx_is_bx_lim   = ((bxFlag0 & BX_IS_BX_LIM) != 0);
      bx0_is_bx_lim  = (bx_is_bx0 && bx_is_bx_lim);
      bx_is_btbx0    = (bt_is_bt0 && bx_is_bx0);
      bx_is_btbx_lim = (bt_is_bt_lim && bx_is_bx_lim);
    }

    //BXK
    //BxIsOnSkip   bx_is_on_skip   : 1;
    BxIsOnSkip   bx_is_on_skip   ;
    inline void resetBXK(const BxIsOnSkip& bx_is_on_skip0) {
      bx_is_on_skip = (bx_is_on_skip0);
    }

    //BY
    //ByIsBy0      by_is_by0       : 1;
    //PrevFlag     prevFlag        : 3;
    //bool         bxy_is_bxy0     : 1;
    //bool         hasPrevML       : 1;
    //bool         hasPrevIL       : 1;
    //bool         hasPrevDL       : 1;
    ByIsBy0      by_is_by0       ;
    PrevFlag     prevFlag        ;
    bool         bxy_is_bxy0     ;
    bool         hasPrevML       ;
    bool         hasPrevIL       ;
    bool         hasPrevDL       ;
    inline void resetBY(const ByIsBy0& by_is_by00,
			const PrevFlag& prevFlag0) {
      by_is_by0     = (by_is_by00);

      bxy_is_bxy0   = (bx_is_btbx0 && by_is_by0);
      prevFlag      = (prevFlag0);
      hasPrevML     = ((prevFlag & FLAG_PREV_ML) != 0);
      hasPrevIL     = ((prevFlag & FLAG_PREV_IL) != 0);
      hasPrevDL     = ((prevFlag & FLAG_PREV_DL) != 0);
    }

    //BYK
    //BIsOnSkip    b_is_on_skip    : 1;
    BIsOnSkip    b_is_on_skip    ;
    inline void resetBYK(const BIsOnSkip& b_is_on_skip0) {
      b_is_on_skip = (b_is_on_skip0);
    }

    //ET
    //EtIsEt0      et_is_et0       : 1;
    //EtCmpByext   et_cmp_byext    : 2;
    //bool         et_is_byext     : 1; 
    //bool         et_le_byext     : 1; 
    //bool         et_lt_byext     : 1; 
    //bool         et_ge_byext     : 1; 
    //bool         et_gt_byext     : 1;
    EtIsEt0      et_is_et0       ;
    EtCmpByext   et_cmp_byext    ;
    bool         et_is_byext     ; 
    bool         et_le_byext     ; 
    bool         et_lt_byext     ; 
    bool         et_ge_byext     ; 
    bool         et_gt_byext     ;
    inline void resetET(const EtIsEt0& et_is_et00,
			const EtCmpByext& et_cmp_byext0) {
      et_is_et0    = (et_is_et00);
      et_cmp_byext = (et_cmp_byext0);
      et_is_byext  = (et_cmp_byext == ET_IS_BYEXT);
      et_le_byext  = (et_cmp_byext <= ET_IS_BYEXT);
      et_lt_byext  = (et_cmp_byext <  ET_IS_BYEXT);
      et_ge_byext  = (et_cmp_byext >= ET_IS_BYEXT);
      et_gt_byext  = (et_cmp_byext >  ET_IS_BYEXT);
    }

    TZState      Et;

    //EX
    //ExIsEx0      ex_is_ex0       : 1;
    //ExCmpByex    ex_cmp_byex     : 2;
    //bool         ex_is_etex0     : 1;
    //bool         ex_is_byex      : 1; 
    //bool         ex_le_byex      : 1; 
    //bool         ex_lt_byex      : 1; 
    //bool         ex_ge_byex      : 1; 
    //bool         ex_gt_byex      : 1;
    //bool         hasPrevDR       : 1;
    ExIsEx0      ex_is_ex0       ;
    ExCmpByex    ex_cmp_byex     ;
    bool         ex_is_etex0     ;
    bool         ex_is_byex      ; 
    bool         ex_le_byex      ; 
    bool         ex_lt_byex      ; 
    bool         ex_ge_byex      ; 
    bool         ex_gt_byex      ;
    bool         hasPrevDR       ;
    inline void resetEX(const ExIsEx0& ex_is_ex00,
			const ExCmpByex& ex_cmp_byex0) {
	ex_is_ex0   = (ex_is_ex00);

	ex_is_etex0 = (et_is_et0 && ex_is_ex0);
	ex_cmp_byex = (ex_cmp_byex0);
	ex_is_byex  = (ex_cmp_byex == EX_IS_BYEX);
	ex_le_byex  = (ex_cmp_byex <= EX_IS_BYEX);
	ex_lt_byex  = (ex_cmp_byex <  EX_IS_BYEX);
	ex_ge_byex  = (ex_cmp_byex >= EX_IS_BYEX);
	ex_gt_byex  = (ex_cmp_byex >  EX_IS_BYEX);
	hasPrevDR   = (ex_is_etex0);
    }

    //EXK
    //ExIsOnSkip   ex_is_on_skip   : 1;
    ExIsOnSkip   ex_is_on_skip   ;
    inline void resetEXK(const ExIsOnSkip& ex_is_on_skip0) {
      ex_is_on_skip = (ex_is_on_skip0);
    }

    //EY
    //EyIsEy0      ey_is_ey0       : 1;
    //bool         exy_is_exy0     : 1;
    //ExyType      exy_type        : 2;
    EyIsEy0      ey_is_ey0       ;
    bool         exy_is_exy0     ;
    ExyType      exy_type        ;
    inline void resetEY(const EyIsEy0& ey_is_ey00) {
      ey_is_ey0     = (ey_is_ey00);

      exy_is_exy0   = (ex_is_etex0 && ey_is_ey0);
      exy_type = (exy_is_exy0
		  ? (bxy_is_bxy0 ? BE_IS_BE0 : EXY_IS_EXY0)
		  : EXY_IS_GENERIC);
    }
    inline const ExyType& getType() const {return exy_type;}

    //EYK
    //RectIsOnSkip rect_is_on_skip : 1;
    RectIsOnSkip rect_is_on_skip ;

    inline void resetEYK(const RectIsOnSkip& rect_is_on_skip0) {
      rect_is_on_skip = (rect_is_on_skip0);
    }

    void clear() {memset(this, 0, sizeof(StateFlags));}
  };
	
  static const Model& model;
#ifdef DEBUG	 
  DPDeckPSCFG& dpDeck;
  VTZ& vt;
  VX& vx;
  VY& vy;
  VPairX& vpairX;
  VPairY& vpairY;
  VBE& vbe;
  VSC& vsc;
  VSkip& vskip;
  VTB& vtb;
  VTBBF& vtbbf;
  VSFBWB& vsfbwB;
  VSFBWE& vsfbwE;
  VFBW& vfw;
  VFBW& vbw;
  DPTask& dpTask;
  VSTB& vstb;
  VSTE& vste;
  const DPRegion& dpRegion;
  const DPRegion::Region& region;
  const SkipSet& skipSet;
#endif

  ScoreManager& scoreManager;
  Task& task;
  StateFlags stateFlags;
 
  int dpAreaMargin;
  State state0;
  State state_lim;
  DPScoreT finalScore;
  State finalState;
   
  ScoreManager::SCNode* scb_store;
  ScoreManager::SCNode* sce_store;

  TBNode* tau;
  TBBFNode* tau_BF;

  //TZNode* bt0;
  TZNode* bt_lim;
  TZNode* et0;
  TZNode* et_lim;
  TZNode* bt;
  TZNode* et;

  XNode* bx0;
  XNode* bx_lim;
  YNode* by0;
  YNode* by_lim;
  XNode* ex0;
  XNode* ex_lim;
  YNode* ey0;
  YNode* ey_lim;
  XNode* bx;           
  YNode* by;           
  XNode* ex;
  YNode* ey;     

  int l_margin;
         
  PairNode* pairX;
  PairNode* pairY;
  PairNode* prev_pairX;
  PairNode* prev_pairY;

  BENode* bn;
  BENode* en0;         
  BENode* en;           

  ScoreManager::SCNode* curr_sc;      
  ScoreManager::SCNode* prevIL; 
  ScoreManager::SCNode* prevDL; 
  ScoreManager::SCNode* prevDR; 
  
  ScoreManager::SCNode prev_sc;      
  ScoreManager::SCNode diag_sc;

  int bxn_beg;
  int bxn_last;
  int exn_beg;
  int exn_last;
  int mxn_beg;
  int mxn_last;
  int bxr0;
  int exr0;

  int bxr;
  int exr;
  int bxn;
  int exn;

  int skipSize;
  int* pSkipCountB0;
  int* pSkipCountE00;
  int* pSkipCountE0;
  int* pSkipCountM0;

  int h_bxn;
  int h_exn;
  int h_byexn;
  int h_eybxn;
  int h_intsec;
  int* pSkipCount0;
  int* pSkipCountL;
  int* pSkipShiftL;
  int* pSkipCountR;
  int* pSkipShiftR;

  int skipRowCount;
  int skipCount;
  int* pSkipCount;
  DPScoreT* scVSTRect1;
  DPScoreT* scVSTRect2;
  DPScoreT* scVSTRect20;

  int best_child_index;
  State best_state;
  DPScoreT best_score;
  DPScoreT best_score1;
  DPScoreT* best_split_ptr_plus_1;
  BFType best_bfType;
  int best_split_offset;

#ifdef SLR_STATE
  DPScoreT best_score_L;
  DPScoreT best_score_R;
#endif

  ScoreManager::ESCTable escTable;
  ScoreManager::TSCTable tscTable;

#ifdef DEBUG
  mutable DPRegion::Region::Iterator<Task::insideType> dpi;
  mutable DPRegion::Region::BFIterator<Task::insideType> bfi;
#endif
  
  void clear();
  void reset();
  //void reset(Task& task);
  void computeFinalScoreState();


  //inline void dpProcBT();
  ////inline void dpProcBTInit(const BT& BT0);
  //inline void dpProcBTUpdate();
  //inline void chooseDPProcBX(const BT& BT0);
  //inline void dpProcBX(const BT& BT0, int tzType0);
  //inline void dpProcBXInit();
  //inline void dpProcBXUpdate(const BX& BX0);
  //inline void dpProcBXSkip(const BX& BX0);
  //inline void dpProcBY(const BX& BX0, bool bx_is_on_skip0);
  //inline void dpProcBYInit();
  //inline void dpProcBYUpdate();
  //inline void dpProcBYSkip(const BY& BY0);
  //inline void dpProcBYSkipStoreE(const BY& BY0);
  //inline void dpProcET(const BY& BY0, bool b_is_on_skip0);
  //inline void dpProcETInit(const ET& ET0);
  //inline void dpProcETUpDate(const ET& ET0);
  //inline void dpProcETInitSCMP();
  //inline void dpProcETInitSkipCountE();
  //inline void chooseDPProcEX(const ET& ET0);
  //inline void dpProcEX(const ET& ET0, int tzType0);
  //inline void dpProcEXInit(const EX& EX0);
  //inline void dpProcEXUpdate(const EX& EX0);
  //inline void dpProcEXSkip(const EX& EX0);
  //inline void dpProcEY(const EX& EX0, bool ex_is_on_skip0);
  //inline void dpProcEYInit();
  //inline void dpProcEYUpdate(const EY& EY0);
  //inline void dpProcEYSkip(const EY& EY0);
  //inline void dpProc(const EYK& EYK0);
  //inline void dpProcState(const EYK& EYK0, const State& s);
  //inline DPScoreT getPreviousScore(const EYK& EYK0,
  //				   const State& s,
  //				   const State& s1) const;

  inline void dpProcBT();
  //inline void dpProcBTInit();
  inline void dpProcBTUpdate();
  inline void chooseDPProcBX();
  inline void dpProcBX();
  inline void dpProcBXInit();
  inline void dpProcBXUpdate();
  inline void dpProcBXSkip();
  inline void dpProcBY();
  inline void dpProcBYInit();
  inline void dpProcBYUpdate();
  inline void dpProcBYSkip();
  inline void dpProcBYSkipStoreE();
  inline void dpProcET();
  inline void dpProcETInit();
  inline void dpProcETUpDate();
  inline void dpProcETInitSCMP();
  inline void dpProcETInitSkipCountE();
  inline void chooseDPProcEX();
  inline void dpProcEX();
  inline void dpProcEXInit();
  inline void dpProcEXUpdate();
  inline void dpProcEXSkip();
  inline void dpProcEY();
  inline void dpProcEYInit();
  inline void dpProcEYUpdate();
  inline void dpProcEYSkip();
  inline void dpProc();
  inline void dpProcState(const State& s);
  inline DPScoreT getPreviousScore(const State& s,
				   const State& s1) const;


  inline DPScoreT esc(const State& s, const State& s1) const;
  inline DPScoreT tsc(const State& s, const State& s1) const;
  inline void dpProcInitST();
  inline void dpProcUpdateST();
  inline void dpProcBifurcate();
  inline void dpProcBifurcateBFType0();
  inline void dpProcBifurcateBFType1();
  inline void dpProcBifurcateBFType2();
#define USE_TEMPLATE_BF
#if defined(USE_TEMPLATE_BF)
  template <Forward forward, L1R2 l1_r2, 
  	    HasIntsec hasIntSec, BFType bfType>
  inline void dpProcBifurcateHexagon();
  template <Forward forward, L1R2 l1_r2, 
	    BFType bfType, MarginType marginType>
  inline void dpProcBifurcateLoop();
#else
  inline void dpProcBifurcateHexagon(Forward forward, L1R2 l1_r2, 
				     HasIntsec hasIntSec, BFType bfType);
  inline void dpProcBifurcateLoop(Forward forward, L1R2 l1_r2, 
				  BFType bfType, MarginType marginType);
#endif

  // test methods
  Rect getCurrRect() const;
  void testInitialState() const;
  void testFinalState() const;

  //void testDPProcInitialState(const EYK& EYK0) const;
  //void testDPProcFinalState(const EYK& EYK0) const;

  void testDPProcInitialState() const;
  void testDPProcFinalState() const;


  void testDPProcBifurcateInitialState() const;
  void testDPProcBifurcateFinalState() const;
  //template <BFType bfType>
  //void testDPProcBifurcateLoopInitialState() const;
  void testDPProcBifurcateLoopInitialState(BFType bfType) const;
  //template <Forward forward, L1R2 l1_r2,
  //	    BFType bfType, MarginType marginType>
  //void testDPProcBifurcateLoopTransientState() const;
  void testDPProcBifurcateLoopTransientState(Forward forward, L1R2 l1_r2,
					     BFType bfType, MarginType marginType) const;
  //template <BFType bfType>
  //void testDPProcBifurcateLoopFinalState() const;
  void testDPProcBifurcateLoopFinalState(BFType bfType) const;
};

#endif
