/*
 * SkipSet.hpp
 *
 */
#ifndef SKIP_SET_HPP
#define SKIP_SET_HPP

#include "Rect.hpp"
class DPPath;
class SkipSet {
public:
  SkipSet();
  SkipSet(const SkipSet& skipSet);
  ~SkipSet();
  SkipSet& operator=(const SkipSet& skipSet);

  void setSkipSize(const int& skipSize0);
  void setYOffsets(const DPPath& dpPath);//should be set after setSkipSize()
  int getSkipSize() const;
  int getSkipRowPeriod() const;
  int getHorizPeriod() const;
  //int getVertPeriod() const;
  int getDiagPeriod() const;
  bool isSkipRow(const int& x) const;
  bool isSkipPoint(const Point& pt) const;
  bool isSkipRect(const Rect& rect) const;
  int findFirstSkipRow(const int& x) const;
  int findLastSkipRow(const int& x) const;
  int findFirstSkipRowXRange(const int& x_beg, const int& x_last) const;
  int findLastSkipRowXRange(const int& x_beg, const int& x_last) const;
  int getNSkipRow(const int& x_beg, const int& x_last) const;
  int findFirstSkipY(const Point& pt) const;
  int findLastSkipY(const Point& pt) const;
  int findFirstSkipYRange(const int& x,
			  const int& y_beg, const int& y_last) const;
  int findLastSkipYRange(const int& x,
			 const int& y_beg, const int& y_last) const;
  int findFirstSkipX(const Point& pt) const;
  int findLastSkipX(const Point& pt) const;
  Point findFirstSkipDiag(const Point& pt) const;
  Point findLastSkipDiag(const Point& pt) const;
  int getNSkipPointY(const int& x, 
		     const int& y_beg, const int& y_last) const;
  void getSkipYRange(const int& x, int& y_beg, int& y_last, int& ly) const;
  int getNSkipPointX(const int& x_beg, const int& x_last,
		     const int& y) const;

  bool isSkipPoint0(int x, int y) const;
  int findFirstSkipRow0(int x) const;
  string toString() const;
  void print() const;
private:
  typedef std::div_t DivT;
  static const Point pt0; // pt0.x <= 0, pt0.y <= 0
  int skipSize;
  Array<int> y0;// y0[xn] <= 0
  DivT divmodX(const int& x) const;
};

#endif
